![GitHub Release](https://img.shields.io/github/v/release/OpenTerrace/openterrace-python) ![PyPI - Version](https://img.shields.io/pypi/v/openterrace)
![PyPI - Python Version](https://img.shields.io/pypi/pyversions/openterrace) ![GitHub Actions Workflow Status](https://img.shields.io/github/actions/workflow/status/openterrace/openterrace-python/pytest.yml) ![GitHub Issues](https://img.shields.io/github/issues/openterrace/openterrace-python
)


![Logo](https://raw.githubusercontent.com/OpenTerrace/openterrace-python/main/docs/_figures/logo-openterrace.svg)

OpenTerrace is a pure Python framework for packed bed thermal energy storage simulations. It is built from the ground up to be flexible and extendable on modern Python 3.x with speed in mind.

OpenTerrace uses awesome open-source software such as
[Numba](https://numba.pydata.org), [NumPy](https://numpy.org/) and [SciPy](https://scipy.org/):grey_exclamation:

### [Read the documentation of OpenTerrace](https://openterrace.github.io/openterrace-python/)

## Why OpenTerrace?
- **FAST**  
By making use of modern compilers and optimised tri-diagonal matrix solvers, OpenTerrace is built to be fast.

- **FLEXIBLE**  
OpenTerrace is built from the ground up to be flexible for easy integration in system models or optimisation loops.

- **EXTENDABLE**  
Modules for new materials such as non-spherical rocks or exotic Phase Change Materials (PCM) can easily be plugged into the OpenTerrace framework.

## Want to contribute?
Contributions are welcome :pray: Feel free to send pull requests or get in touch with me to discuss how to collaborate. More details in the [docs](https://openterrace.github.io/openterrace-python/).

## Code contributors
* Jakob Hærvig, Associate Professor, AAU Energy, Aalborg University, Denmark